diff --git a/src/main/java/net/minecraft/core/block/material/MaterialColor.java b/src/main/java/net/minecraft/core/block/material/MaterialColor.java
index 2a76416a4..e8ab9faef 100644
--- a/src/main/java/net/minecraft/core/block/material/MaterialColor.java
+++ b/src/main/java/net/minecraft/core/block/material/MaterialColor.java
@@ -1,17 +1,16 @@
 package net.minecraft.core.block.material;
 
 
-public class MaterialColor
-{
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 
-    private MaterialColor(int id, int col)
-    {
-        this.id = id;
-        this.col = col;
-        materialColors[id] = this;
-    }
+import java.util.HashMap;
+import java.util.Map;
 
-    public static final MaterialColor[] materialColors = new MaterialColor[16];
+public class MaterialColor {
+    private static final int ALLOCATED_COLORS = 0b1000000;
+    private static final MaterialColor[] materialColors = new MaterialColor[ALLOCATED_COLORS];
+    // <<<<< Original pallet >>>>>
     public static final MaterialColor none = new MaterialColor(0, 0);
     public static final MaterialColor grass = new MaterialColor(1, 0x7fb238);
     public static final MaterialColor sand = new MaterialColor(2, 0xf7e9a3);
@@ -19,14 +18,125 @@ public class MaterialColor
     public static final MaterialColor fire = new MaterialColor(4, 0xff0000);
     public static final MaterialColor ice = new MaterialColor(5, 0xa0a0ff);
     public static final MaterialColor metal = new MaterialColor(6, 0xa7a7a7);
-    public static final MaterialColor plant = new MaterialColor(7, 31744);
+    public static final MaterialColor plant = new MaterialColor(7, 0x007c00);
     public static final MaterialColor snow = new MaterialColor(8, 0xffffff);
     public static final MaterialColor clay = new MaterialColor(9, 0xa4a8b8);
-    public static final MaterialColor dirt = new MaterialColor(10, 0xb76a2f);
+    public static final MaterialColor dirt = new MaterialColor(10, 0x876145);
     public static final MaterialColor stone = new MaterialColor(11, 0x707070);
     public static final MaterialColor water = new MaterialColor(12, 0x4040ff);
     public static final MaterialColor wood = new MaterialColor(13, 0x685332);
-    public final int col;
+    // <<<<< Original pallet >>>>>
+
+    // <<<<< Stone Colors pallet >>>>>
+    public static final MaterialColor limestone = new MaterialColor(14, 0xd9cb9a);
+    public static final MaterialColor granite = new MaterialColor(15, 0xcba17b);
+    public static final MaterialColor basalt = new MaterialColor(16, 0x2e2e2e);
+    public static final MaterialColor permafrost = new MaterialColor(17, 0xa7b6cc);
+    public static final MaterialColor marble = new MaterialColor(18, 0xeaeae0);
+    public static final MaterialColor slate = new MaterialColor(19, 0x6e6b93);
+    public static final MaterialColor netherrack = new MaterialColor(20, 0x6b1013);
+    public static final MaterialColor brick = new MaterialColor(21, 0x7c4536);
+    // <<<<< Stone Colors pallet >>>>>
+
+    // <<<<< Resource Colors pallet >>>>>
+    public static final MaterialColor iron = new MaterialColor(30, 0xececec);
+    public static final MaterialColor gold = new MaterialColor(31, 0xfdf656);
+    public static final MaterialColor lapis = new MaterialColor(32, 0x1e48a7);
+    public static final MaterialColor coal = new MaterialColor(33, 0x141414);
+    public static final MaterialColor olivine = new MaterialColor(34, 0x7cd939);
+    public static final MaterialColor quartz = new MaterialColor(35, 0xf4cdd3);
+    public static final MaterialColor redstone = new MaterialColor(36, 0x930000);
+    public static final MaterialColor steel = new MaterialColor(37, 0x414141);
+    public static final MaterialColor diamond = new MaterialColor(38, 0x84e3df);
+    // <<<<< Resource Colors pallet >>>>>
+    // <<<<< Environment Colors pallet >>>>>
+    public static final MaterialColor dirtScorched = new MaterialColor(40, 0xb26c2d);
+    public static final MaterialColor grassScorched = new MaterialColor(41, 0xaf985a);
+    public static final MaterialColor mud = new MaterialColor(42, 0x492e10);
+
+
+    public static final MaterialColor birchLeaves = new MaterialColor(43, 0x639472);
+    public static final MaterialColor thornLeaves = new MaterialColor(44, 0x929340);
+    public static final MaterialColor pineLeaves = new MaterialColor(45, 0x253c25);
+    public static final MaterialColor palmLeaves = new MaterialColor(46, 0x607313);
+    public static final MaterialColor cherryLeaves = new MaterialColor(47, 0xc36f8f);
+    // <<<<< Environment Colors pallet >>>>>
+
+    // <<<<< Painted Colors pallet >>>>>
+    public static final MaterialColor paintedWhite = new MaterialColor(48, 0xffffff);
+    public static final MaterialColor paintedOrange = new MaterialColor(49, 0xe87126);
+    public static final MaterialColor paintedMagenta = new MaterialColor(50, 0xb443c2);
+    public static final MaterialColor paintedLightblue = new MaterialColor(51, 0x5a7eca);
+    public static final MaterialColor paintedYellow = new MaterialColor(52, 0xd3c55f);
+    public static final MaterialColor paintedLime = new MaterialColor(53, 0x54b24f);
+    public static final MaterialColor paintedPink = new MaterialColor(54, 0xdb6f8d);
+    public static final MaterialColor paintedGrey = new MaterialColor(55, 0x484848);
+    public static final MaterialColor paintedSilver = new MaterialColor(56, 0x969e9e);
+    public static final MaterialColor paintedCyan = new MaterialColor(57, 0x398796);
+    public static final MaterialColor paintedPurple = new MaterialColor(58, 0x7c44db);
+    public static final MaterialColor paintedBlue = new MaterialColor(59, 0x2131e9);
+    public static final MaterialColor paintedBrown = new MaterialColor(60, 0x6e321c);
+    public static final MaterialColor paintedGreen = new MaterialColor(61, 0x266326);
+    public static final MaterialColor paintedRed = new MaterialColor(62, 0xed33434);
+    public static final MaterialColor paintedBlack = new MaterialColor(63, 0x020202);
+    // <<<<< Painted Colors pallet >>>>>
+    private static final Map<Integer, Integer> blockIdColorIndexMap = new HashMap<>();
+    private final int col;
     public final int id;
+    private MaterialColor(int id, int col)
+    {
+        this.id = id;
+        this.col = col;
+        materialColors[id] = this;
+    }
+
+    private static int makeBlockIndex(Block block, int meta){
+        return block.id << 8 | meta;
+    }
+    public static void registerManualBlockColor(Block block, int meta, MaterialColor color){
+        int blockIndex = makeBlockIndex(block, meta);
+        blockIdColorIndexMap.put(blockIndex, color.id);
+    }
+    public static int getColorIndexFromBlock(Block block, int meta){
+        int blockIndex = makeBlockIndex(block, meta);
+        if (blockIdColorIndexMap.containsKey(blockIndex)){
+            return blockIdColorIndexMap.get(blockIndex);
+        }
+        blockIndex = makeBlockIndex(block, 0);
+        if (blockIdColorIndexMap.containsKey(blockIndex)){
+            return blockIdColorIndexMap.get(blockIndex);
+        }
+        return block.getMaterialColor().id;
+    }
+    public static int getColorFromIndex(int colorIndex){
+        colorIndex &= (ALLOCATED_COLORS - 1);
+        MaterialColor col = materialColors[colorIndex];
+        if (col == null) return none.col;
+        return col.col;
+    }
+
+    public static void assignManualEntries(){
+        for (int i = 0; i < 16; i++) {
+            MaterialColor color = materialColors[i + paintedWhite.id];
+            registerManualBlockColor(Blocks.PLANKS_OAK_PAINTED, i, color);
+            registerManualBlockColor(Blocks.WOOL, i, color);
+            registerManualBlockColor(Blocks.FENCE_PLANKS_OAK_PAINTED, i, color);
+            // Fill out each rotation value for rotated colored blocks
+            for (int j = 0; j < 16; j++) {
+                registerManualBlockColor(Blocks.SLAB_PLANKS_PAINTED, i << 4 | j, color);
+                registerManualBlockColor(Blocks.CHEST_PLANKS_OAK_PAINTED, i << 4 | j, color);
+                registerManualBlockColor(Blocks.CHEST_LEGACY_PAINTED, i << 4 | j, color);
+                registerManualBlockColor(Blocks.STAIRS_PLANKS_PAINTED, i << 4 | j, color);
+                registerManualBlockColor(Blocks.TRAPDOOR_PLANKS_PAINTED, i << 4 | j, color);
+                registerManualBlockColor(Blocks.DOOR_PLANKS_PAINTED_BOTTOM, i << 4 | j, color);
+                registerManualBlockColor(Blocks.DOOR_PLANKS_PAINTED_TOP, i << 4 | j, color);
+            }
+            registerManualBlockColor(Blocks.LAMP_ACTIVE, i, color);
+            registerManualBlockColor(Blocks.LAMP_IDLE, i, color);
+        }
 
+        for (int i = 1; i < 256; i++) {
+            registerManualBlockColor(Blocks.FARMLAND_DIRT, i, mud);
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java b/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java
similarity index 79%
rename from src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java
rename to src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java
index f54487a8f..ea4582340 100644
--- a/src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java
+++ b/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java
@@ -1,12 +1,13 @@
 package net.minecraft.core.block.piston;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.logic.PistonDirections;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.block.ItemBlockPiston;
+import net.minecraft.core.item.block.PistonBlockItem;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
@@ -16,14 +17,14 @@ import net.minecraft.core.world.WorldSource;
 
 import java.util.ArrayList;
 
-public class BlockPistonBase extends Block
+public class BasePistonBlock extends Block
 {
 
-    public BlockPistonBase(String key, int id, boolean isSticky)
+    public BasePistonBlock(String key, String namespaceId, int id, boolean isSticky)
     {
-        super(key, id, Material.piston);
+        super(key, namespaceId, id, Material.piston);
         this.isSticky = isSticky;
-        setBlockItem(() -> new ItemBlockPiston(this));
+        setBlockItem(() -> new PistonBlockItem(this));
         withHardness(0.5F);
     }
 
@@ -34,8 +35,8 @@ public class BlockPistonBase extends Block
     }
 
     @Override
-    public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
-    	Direction placementDirection = entity.getPlacementDirection(side).getOpposite();
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    	Direction placementDirection = mob.getPlacementDirection(side).getOpposite();
         world.setBlockMetadataWithNotify(x, y, z, placementDirection.getId());
         if(!world.isClientSide)
         {
@@ -50,9 +51,9 @@ public class BlockPistonBase extends Block
     }
 
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        if(!world.isClientSide && world.getBlockTileEntity(x, y, z) == null)
+        if(!world.isClientSide && world.getBlockEntity(x, y, z) == null)
         {
             checkIfExtend(world, x, y, z);
         }
@@ -63,7 +64,7 @@ public class BlockPistonBase extends Block
         int data = world.getBlockMetadata(x, y, z);
         int direction = getDirection(data);
         boolean hasNeighborSignal = getNeighborSignal(world, x, y, z, direction);
-        if(data == 7)
+        if(data == 0b111)
         {
             return;
         }
@@ -82,53 +83,41 @@ public class BlockPistonBase extends Block
         }
     }
 
-    private boolean getNeighborSignal(World world, int x, int y, int z, int direction)
-    {
-        if(direction != 0 && world.isBlockIndirectlyProvidingPowerTo(x, y - 1, z, 0))
-        {
+    private boolean getNeighborSignal(World world, int x, int y, int z, int direction) {
+        if(direction != 0 && world.isBlockIndirectlyProvidingPowerTo(x, y - 1, z, Side.BOTTOM)) {
             return true;
         }
-        if(direction != 1 && world.isBlockIndirectlyProvidingPowerTo(x, y + 1, z, 1))
-        {
+        if(direction != 1 && world.isBlockIndirectlyProvidingPowerTo(x, y + 1, z, Side.TOP)) {
             return true;
         }
-        if(direction != 2 && world.isBlockIndirectlyProvidingPowerTo(x, y, z - 1, 2))
-        {
+        if(direction != 2 && world.isBlockIndirectlyProvidingPowerTo(x, y, z - 1, Side.NORTH)) {
             return true;
         }
-        if(direction != 3 && world.isBlockIndirectlyProvidingPowerTo(x, y, z + 1, 3))
-        {
+        if(direction != 3 && world.isBlockIndirectlyProvidingPowerTo(x, y, z + 1, Side.SOUTH)) {
             return true;
         }
-        if(direction != 5 && world.isBlockIndirectlyProvidingPowerTo(x + 1, y, z, 5))
-        {
+        if(direction != 5 && world.isBlockIndirectlyProvidingPowerTo(x + 1, y, z, Side.EAST)) {
             return true;
         }
-        if(direction != 4 && world.isBlockIndirectlyProvidingPowerTo(x - 1, y, z, 4))
-        {
+        if(direction != 4 && world.isBlockIndirectlyProvidingPowerTo(x - 1, y, z, Side.WEST)) {
             return true;
         }
-        if(world.isBlockIndirectlyProvidingPowerTo(x, y, z, 0))
-        {
+        if(world.isBlockIndirectlyProvidingPowerTo(x, y, z, Side.BOTTOM)) {
             return true;
         }
-        if(world.isBlockIndirectlyProvidingPowerTo(x, y + 2, z, 1))
-        {
+        if(world.isBlockIndirectlyProvidingPowerTo(x, y + 2, z, Side.TOP)) {
             return true;
         }
-        if(world.isBlockIndirectlyProvidingPowerTo(x, y + 1, z - 1, 2))
-        {
+        if(world.isBlockIndirectlyProvidingPowerTo(x, y + 1, z - 1, Side.NORTH)) {
             return true;
         }
-        if(world.isBlockIndirectlyProvidingPowerTo(x, y + 1, z + 1, 3))
-        {
+        if(world.isBlockIndirectlyProvidingPowerTo(x, y + 1, z + 1, Side.SOUTH)) {
             return true;
         }
-        if(world.isBlockIndirectlyProvidingPowerTo(x - 1, y + 1, z, 4))
-        {
+        if(world.isBlockIndirectlyProvidingPowerTo(x - 1, y + 1, z, Side.WEST)) {
             return true;
         }
-        return world.isBlockIndirectlyProvidingPowerTo(x + 1, y + 1, z, 5);
+        return world.isBlockIndirectlyProvidingPowerTo(x + 1, y + 1, z, Side.EAST);
     }
 
     @Override
@@ -146,13 +135,13 @@ public class BlockPistonBase extends Block
         }
         else if(index == 1)
         {
-            TileEntity tileentity = world.getBlockTileEntity(x + PistonDirections.xOffset[direction], y + PistonDirections.yOffset[direction], z + PistonDirections.zOffset[direction]);
-            if(tileentity != null && (tileentity instanceof TileEntityPistonMoving))
+            BlockEntity tileentity = world.getBlockEntity(x + PistonDirections.xOffset[direction], y + PistonDirections.yOffset[direction], z + PistonDirections.zOffset[direction]);
+            if(tileentity != null && (tileentity instanceof MovingPistonBlockEntity))
             {
-                ((TileEntityPistonMoving)tileentity).finalTick();
+                ((MovingPistonBlockEntity)tileentity).finalTick();
             }
-            world.setBlockAndMetadata(x, y, z, Block.pistonMoving.id, direction);
-            world.setBlockTileEntity(x, y, z, BlockPistonMoving.createTileEntity(id, direction, direction, false, true));
+            world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, direction);
+            world.setBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(id, direction, direction, false, true));
             if(isSticky)
             {
                 int x1 = x + PistonDirections.xOffset[direction] * 2;
@@ -161,12 +150,12 @@ public class BlockPistonBase extends Block
                 int id1 = world.getBlockId(x1, y1, z1);
                 int meta1 = world.getBlockMetadata(x1, y1, z1);
                 boolean flag = false;
-                if(id1 == Block.pistonMoving.id)
+                if(id1 == Blocks.PISTON_MOVING.id)
                 {
-                    TileEntity tileentity1 = world.getBlockTileEntity(x1, y1, z1);
-                    if(tileentity1 != null && (tileentity1 instanceof TileEntityPistonMoving))
+                    BlockEntity tileentity1 = world.getBlockEntity(x1, y1, z1);
+                    if(tileentity1 != null && (tileentity1 instanceof MovingPistonBlockEntity))
                     {
-                        TileEntityPistonMoving tileentitypiston = (TileEntityPistonMoving)tileentity1;
+                        MovingPistonBlockEntity tileentitypiston = (MovingPistonBlockEntity)tileentity1;
                         if(tileentitypiston.getDirection() == direction && tileentitypiston.isExtending())
                         {
                             tileentitypiston.finalTick();
@@ -176,14 +165,14 @@ public class BlockPistonBase extends Block
                         }
                     }
                 }
-                if(!flag && id1 > 0 && isPushable(id1, world, x1, y1, z1, false) && (Block.blocksList[id1].getPistonPushReaction() == 0 || id1 == Block.pistonBase.id || id1 == Block.pistonBaseSticky.id))
+                if(!flag && id1 > 0 && isPushable(id1, world, x1, y1, z1, false) && (Block.blocksList[id1].getPistonPushReaction() == 0 || id1 == Blocks.PISTON_BASE.id || id1 == Blocks.PISTON_BASE_STICKY.id))
                 {
                     world.setBlockWithNotify(x1, y1, z1, 0);
                     x += PistonDirections.xOffset[direction];
                     y += PistonDirections.yOffset[direction];
                     z += PistonDirections.zOffset[direction];
-                    world.setBlockAndMetadata(x, y, z, Block.pistonMoving.id, meta1);
-                    world.setBlockTileEntity(x, y, z, BlockPistonMoving.createTileEntity(id1, meta1, direction, false, false));
+                    world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, meta1);
+                    world.setBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(id1, meta1, direction, false, false));
                 } else
                 if(!flag)
                 {
@@ -237,14 +226,14 @@ public class BlockPistonBase extends Block
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
 
     public static int getDirection(int data)
     {
-        return data & 7;
+        return data & 0b111;
     }
 
     public static boolean isPowered(int data)
@@ -254,11 +243,11 @@ public class BlockPistonBase extends Block
     
     private static boolean isPushable(int id, World world, int x, int y, int z, boolean canDestroy)
     {
-        if(id == Block.obsidian.id)
+        if(id == Blocks.OBSIDIAN.id)
         {
             return false;
         }
-        if(id == Block.pistonBase.id || id == Block.pistonBaseSticky.id)
+        if(id == Blocks.PISTON_BASE.id || id == Blocks.PISTON_BASE_STICKY.id)
         {
             if(isPowered(world.getBlockMetadata(x, y, z)))
             {
@@ -283,7 +272,7 @@ public class BlockPistonBase extends Block
                 return false;
             }
         }
-        TileEntity tileentity = world.getBlockTileEntity(x, y, z);
+        BlockEntity tileentity = world.getBlockEntity(x, y, z);
         return tileentity == null;
     }
 
@@ -310,7 +299,7 @@ public class BlockPistonBase extends Block
             }
             if(!isPushable(id, world, xo, yo, zo, true))
             {
-                if(i == 1 && (id == Block.obsidian.id || id == Block.bedrock.id)){
+                if(i == 1 && (id == Blocks.OBSIDIAN.id || id == Blocks.BEDROCK.id)){
                     int x2 = x + PistonDirections.xOffset[direction % 6];
                     int y2 = y + PistonDirections.yOffset[direction % 6];
                     int z2 = z + PistonDirections.zOffset[direction % 6];
@@ -387,12 +376,12 @@ public class BlockPistonBase extends Block
             int j3 = world.getBlockMetadata(i2, k2, l2);
             if(i3 == id && i2 == x && k2 == y && l2 == z)
             {
-                world.setBlockAndMetadata(i1, j1, k1, Block.pistonMoving.id, direction | (isSticky ? 8 : 0));
-                world.setBlockTileEntity(i1, j1, k1, BlockPistonMoving.createTileEntity(Block.pistonHead.id, direction | (isSticky ? 8 : 0), direction, true, false));
+                world.setBlockAndMetadata(i1, j1, k1, Blocks.PISTON_MOVING.id, direction | (isSticky ? 8 : 0));
+                world.setBlockTileEntity(i1, j1, k1, MovingPistonBlock.createTileEntity(Blocks.PISTON_HEAD.id, direction | (isSticky ? 8 : 0), direction, true, false));
             } else
             {
-                world.setBlockAndMetadata(i1, j1, k1, Block.pistonMoving.id, j3);
-                world.setBlockTileEntity(i1, j1, k1, BlockPistonMoving.createTileEntity(i3, j3, direction, true, false));
+                world.setBlockAndMetadata(i1, j1, k1, Blocks.PISTON_MOVING.id, j3);
+                world.setBlockTileEntity(i1, j1, k1, MovingPistonBlock.createTileEntity(i3, j3, direction, true, false));
             }
             i1 = i2;
             j1 = k2;
diff --git a/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java
similarity index 73%
rename from src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
rename to src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java
index f5c4d0778..a85ad3f76 100644
--- a/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
+++ b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java
@@ -1,8 +1,9 @@
 package net.minecraft.core.block.piston;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockTileEntity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.EntityBlock;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.logic.PistonDirections;
@@ -10,41 +11,40 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 
 // Referenced classes of package net.minecraft.src:
 //            BlockContainer, Material, World, TileEntityPiston, 
 //            Block, PistonBlockTextures, AxisAlignedBB, IBlockAccess, 
-//            TileEntity, EntityPlayer
+//            BlockEntity, Player
 
-public class BlockPistonMoving extends BlockTileEntity
+public class MovingPistonBlock extends EntityBlock
 {
 
-    public BlockPistonMoving(String key, int id)
+    public MovingPistonBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.piston);
+        super(key, namespaceId, id, Material.piston);
         withHardness(-1F);
     }
 
     @Override
-	protected TileEntity getNewBlockEntity()
+	protected BlockEntity getNewBlockEntity()
     {
         return null;
     }
 
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
     }
 
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
-        TileEntity tileentity = world.getBlockTileEntity(x, y, z);
-        if(tileentity != null && (tileentity instanceof TileEntityPistonMoving))
+        BlockEntity tileentity = world.getBlockEntity(x, y, z);
+        if(tileentity != null && (tileentity instanceof MovingPistonBlockEntity))
         {
-            ((TileEntityPistonMoving)tileentity).finalTick();
+            ((MovingPistonBlockEntity)tileentity).finalTick();
         } else
         {
             super.onBlockRemoved(world, x, y, z, data);
@@ -58,7 +58,7 @@ public class BlockPistonMoving extends BlockTileEntity
     }
 
     @Override
-    public boolean canPlaceBlockOnSide(World world, int x, int y, int z, int side)
+    public boolean canPlaceBlockOnSide(World world, int x, int y, int z, Side side)
     {
         return false;
     }
@@ -70,15 +70,15 @@ public class BlockPistonMoving extends BlockTileEntity
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
-        if(!world.isClientSide && world.getBlockTileEntity(x, y, z) == null)
+        if(!world.isClientSide && world.getBlockEntity(x, y, z) == null)
         {
             world.setBlockWithNotify(x, y, z, 0);
             return true;
@@ -89,19 +89,19 @@ public class BlockPistonMoving extends BlockTileEntity
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         return null;
     }
 
     @Override
-    public void dropBlockWithCause(World world, EnumDropCause cause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public void dropBlockWithCause(World world, EnumDropCause cause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         if(world.isClientSide)
         {
             return;
         }
-        TileEntityPistonMoving piston = getBlockEntity(world, x, y, z);
+        MovingPistonBlockEntity piston = getBlockEntity(world, x, y, z);
         if(piston != null)
         {
             Block.blocksList[piston.getMovedId()].dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null);
@@ -113,19 +113,19 @@ public class BlockPistonMoving extends BlockTileEntity
     {
         if(!world.isClientSide)
         {
-            if(world.getBlockTileEntity(x, y, z) != null);
+            if(world.getBlockEntity(x, y, z) != null);
         }
     }
 
-    public static TileEntity createTileEntity(int id, int oldData, int newData, boolean flag, boolean flag1)
+    public static BlockEntity createTileEntity(int id, int oldData, int newData, boolean flag, boolean flag1)
     {
-        return new TileEntityPistonMoving(id, oldData, newData, flag, flag1);
+        return new MovingPistonBlockEntity(id, oldData, newData, flag, flag1);
     }
 
     @Override
 	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
-        TileEntityPistonMoving tileEntity = getBlockEntity(world, x, y, z);
+        MovingPistonBlockEntity tileEntity = getBlockEntity(world, x, y, z);
         if(tileEntity == null)
         {
             return null;
@@ -141,7 +141,7 @@ public class BlockPistonMoving extends BlockTileEntity
     @Override
     public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
-        TileEntityPistonMoving tileentitypiston = getBlockEntity(world, x, y, z);
+        MovingPistonBlockEntity tileentitypiston = getBlockEntity(world, x, y, z);
         if(tileentitypiston != null)
         {
             Block block = Block.blocksList[tileentitypiston.getMovedId()];
@@ -187,12 +187,12 @@ public class BlockPistonMoving extends BlockTileEntity
         }
     }
 
-    private TileEntityPistonMoving getBlockEntity(WorldSource world, int x, int y, int z)
+    private MovingPistonBlockEntity getBlockEntity(WorldSource world, int x, int y, int z)
     {
-        TileEntity tileEntity = world.getBlockTileEntity(x, y, z);
-        if(tileEntity instanceof TileEntityPistonMoving)
+        BlockEntity blockEntity = world.getBlockEntity(x, y, z);
+        if(blockEntity instanceof MovingPistonBlockEntity)
         {
-            return (TileEntityPistonMoving)tileEntity;
+            return (MovingPistonBlockEntity) blockEntity;
         }
         else
         {
diff --git a/src/main/java/net/minecraft/core/block/piston/TileEntityPistonMoving.java b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
similarity index 88%
rename from src/main/java/net/minecraft/core/block/piston/TileEntityPistonMoving.java
rename to src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
index 2c838ea84..60f1f042e 100644
--- a/src/main/java/net/minecraft/core/block/piston/TileEntityPistonMoving.java
+++ b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
@@ -1,22 +1,22 @@
 package net.minecraft.core.block.piston;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.phys.AABB;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.logic.PistonDirections;
 
 import java.util.*;
 
-public class TileEntityPistonMoving extends TileEntity
+public class MovingPistonBlockEntity extends BlockEntity
 {
 
-    public TileEntityPistonMoving()
+    public MovingPistonBlockEntity()
     {
     }
 
-    public TileEntityPistonMoving(int movedId, int movedData, int direction, boolean extending, boolean isSourcePiston)
+    public MovingPistonBlockEntity(int movedId, int movedData, int direction, boolean extending, boolean isSourcePiston)
     {
         this.movedId = movedId;
         this.movedData = movedData;
@@ -102,7 +102,7 @@ public class TileEntityPistonMoving extends TileEntity
         {
             f = 1.0F - f;
         }
-        AABB axisalignedbb = ((BlockPistonMoving) Block.pistonMoving).getCollisionShapeFromTileEntity(worldObj, x, y, z, movedId, f, direction);
+        AABB axisalignedbb = ((MovingPistonBlock) Blocks.PISTON_MOVING).getCollisionShapeFromTileEntity(worldObj, x, y, z, movedId, f, direction);
         if(axisalignedbb != null)
         {
             List list = worldObj.getEntitiesWithinAABBExcludingEntity(null, axisalignedbb);
@@ -130,7 +130,7 @@ public class TileEntityPistonMoving extends TileEntity
             progressO = progress = 1.0F;
             worldObj.removeBlockTileEntity(x, y, z);
             invalidate();
-            if(worldObj.getBlockId(x, y, z) == Block.pistonMoving.id)
+            if(worldObj.getBlockId(x, y, z) == Blocks.PISTON_MOVING.id)
             {
                 worldObj.setBlockAndMetadataWithNotify(x, y, z, movedId, movedData);
             }
@@ -146,7 +146,7 @@ public class TileEntityPistonMoving extends TileEntity
             moveCollidedEntities(1.0F, 0.25F);
             worldObj.removeBlockTileEntity(x, y, z);
             invalidate();
-            if(worldObj.getBlockId(x, y, z) == Block.pistonMoving.id)
+            if(worldObj.getBlockId(x, y, z) == Blocks.PISTON_MOVING.id)
             {
                 worldObj.setBlockAndMetadataWithNotify(x, y, z, movedId, movedData);
             }
